<?php
/**
 * @author Joomla! Extensions Store
 * @package JSPEED::plugins::system
 * @copyright (C) 2020 - Joomla! Extensions Store
 * @license GNU/GPLv2 http://www.gnu.org/licenses/gpl-2.0.html
 */

// No direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );
class JSpeedJsonManager {
	/**
	 * Determines whether the request was successful
	 *
	 * @var boolean
	 */
	public $success = true;

	/**
	 * The response message
	 *
	 * @var string
	 */
	public $message = '';

	/**
	 * The error code
	 */
	public $code = 0;

	/**
	 * The response data
	 *
	 * @var mixed
	 */
	public $data = '';

	/**
	 * Magic toString method for sending the response in JSON format
	 *
	 * @return string The response in JSON format
	 */
	public function __toString() {
		@header ( 'Content-Type: application/json; charset=utf-8' );

		$encodedObject = json_encode ( $this );
		
		if($encodedObject) {
			return $encodedObject;
		} else {
			return '{"success":true,"message":"","code":0,"data":{"jform_params_exclude_css":{"success":true,"message":"","code":0,"data":[]},"jform_params_exclude_css_components":{"success":true,"message":"","code":0,"data":[]},"jform_params_exclude_styles":{"success":true,"message":"","code":0,"data":[]},"jform_params_exclude_js_by_order":{"success":true,"message":"","code":0,"data":[]},"jform_params_exclude_js_components_by_order":{"success":true,"message":"","code":0,"data":[]},"jform_params_exclude_scripts_by_order":{"success":true,"message":"","code":0,"data":[]},"jform_params_exclude_js":{"success":true,"message":"","code":0,"data":[]},"jform_params_exclude_js_components":{"success":true,"message":"","code":0,"data":[]},"jform_params_exclude_scripts":{"success":true,"message":"","code":0,"data":[]},"jform_params_menuexcludedurl":{"success":true,"message":"","code":0,"data":[]},"jform_params_exclude_defer":{"success":true,"message":"","code":0,"data":[]},"jform_params_remove_js_files":{"success":true,"message":"","code":0,"data":[]},"jform_params_remove_css_files":{"success":true,"message":"","code":0,"data":[]},"jform_params_remove_font_face_family":{"success":true,"message":"","code":0,"data":[]},"jform_params_img_files_excluded":{"success":true,"message":"","code":0,"data":[]},"jform_params_img_class_excluded":{"success":true,"message":"","code":0,"data":[]},"jform_params_combinedimage_exclude_images":{"success":true,"message":"","code":0,"data":[]},"jform_params_combinedimage_include_images":{"success":true,"message":"","code":0,"data":[]},"jform_params_http2_file_types":{"success":true,"message":"","code":0,"data":[]},"jform_params_excludeLazyLoad":{"success":true,"message":"","code":0,"data":[]},"jform_params_excludeLazyLoadFolders":{"success":true,"message":"","code":0,"data":[]},"jform_params_excludeLazyLoadClass":{"success":true,"message":"","code":0,"data":[]},"jform_params_excludeLazyLoadUrl":{"success":true,"message":"","code":0,"data":[]},"jform_params_cdn_staticfiles":{"success":true,"message":"","code":0,"data":[]},"jform_params_cdn_staticfiles_2":{"success":true,"message":"","code":0,"data":[]},"jform_params_cdn_staticfiles_3":{"success":true,"message":"","code":0,"data":[]},"jform_params_cdn_assets_excluded":{"success":true,"message":"","code":0,"data":[]}}}';
		}
	}

	/**
	 * Constructor
	 *
	 * @param mixed $response
	 *        	The Response data
	 * @param string $message
	 *        	The response message
	 *        	
	 */
	public function __construct($response = null, $message = '') {
		$this->message = $message;

		// Check if we are dealing with an error
		if ($response instanceof Exception) {
			// Prepare the error response
			$this->success = false;
			$this->message = $response->getMessage ();
			$this->code = $response->getCode ();
		} else {
			$this->data = $response;
		}
	}
}
